# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::AzureStack::Mgmt::V2017_06_01
  module Models
    #
    # Product information.
    #
    class VirtualMachineExtensionProductProperties

      include MsRestAzure

      # @return [ComputeRole] Specifies kind of compute role included in the
      # package. Possible values include: 'None', 'IaaS', 'PaaS'
      attr_accessor :compute_role

      # @return [Boolean] Specifies if product is a Virtual Machine Extension.
      attr_accessor :is_system_extension

      # @return [String] The URI.
      attr_accessor :uri

      # @return [Boolean] Indicates if specified product supports multiple
      # extensions.
      attr_accessor :support_multiple_extensions

      # @return [String] Specifies product version.
      attr_accessor :version

      # @return [OperatingSystem] Specifies operating system used by the
      # product. Possible values include: 'None', 'Windows', 'Linux'
      attr_accessor :vm_os_type

      # @return [Boolean] Indicates if virtual machine Scale Set is enabled in
      # the specified product.
      attr_accessor :vm_scale_set_enabled


      #
      # Mapper for VirtualMachineExtensionProductProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'VirtualMachineExtensionProductProperties',
          type: {
            name: 'Composite',
            class_name: 'VirtualMachineExtensionProductProperties',
            model_properties: {
              compute_role: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'computeRole',
                type: {
                  name: 'String'
                }
              },
              is_system_extension: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'isSystemExtension',
                type: {
                  name: 'Boolean'
                }
              },
              uri: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'sourceBlob.uri',
                type: {
                  name: 'String'
                }
              },
              support_multiple_extensions: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'supportMultipleExtensions',
                type: {
                  name: 'Boolean'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'version',
                type: {
                  name: 'String'
                }
              },
              vm_os_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'vmOsType',
                type: {
                  name: 'String'
                }
              },
              vm_scale_set_enabled: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'vmScaleSetEnabled',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
